<?php
//don't allow other scripts to grab and execute our file
defined('_JEXEC') or die;

class Parser{
	
	private $description;
	private $link;
	private $title;
	
	private function parseDesc($tag){
		$del='"';
		
		/*User friendly*/
		if($tag=="image"){
			$tag="src=\"";
		}else if($tag=="speaker"){
			$tag="Speaker: </strong>";
		}else if($tag=="time"){
			$tag="Time: </strong>";
		}else if($tag=="date"){
			$tag="Date: </strong>";
		}else if($tag=="location"){
			$tag="Location: </strong>";
		}else if($tag=="affiliation"){
			$tag="Affiliation: </strong>";
		}else if($tag=="category"){
			$tag="Category: </strong>";
		}else if($tag=="host"){
			$tag="Host: </strong>";
		}else if($tag=="abstract"){
			$tag="Abstract:</strong><br/>";
		}else if($tag=="bio"){
			$tag="Short Bio:</strong><br/>";
		}//else if($tag=="title"){
			//$tag="<h2>";
		//}
		//print $tag;
		$charsDes=str_split($this->description);
		$charsTag = str_split($tag);
		$i=0;
		$j=0;
		while($i!=strlen($this->description)){
			
			if($charsDes[$i]==$charsTag[$j]){
				$j++;
			}else{
				$j=0;
			}
			if($j==strlen($tag)){//if found
				//print "FOUND";
				$i++;
				//print $charsDes[$i+15];
				//print $charsDes[$i+1];
				//i now is on the right character
				while($charsDes[$i]!='"' and $charsDes[$i]!='<'){
					$res.=$charsDes[$i];
					$i++;
				}
				//print $res;
				return $res;
			}
			$i++;
		}
	}
	
	public function getLink(){
		return $this->link;
	}
	
	public function getTitle(){
		return $this->title;
	}
	
	public function __construct($url){
		//print "Parser is constructed!\n";
		//Takes to much time and stops execution
		$this->downloadFile($url);
		//will change to the downloaded rss.xml
		
		
	}
	
	public function parse($post,$tag){
		$xml=simplexml_load_file("/tmp/rss.xml");
		//channel is always 0 , item for each post
		
		
		$this->title=$xml->channel[0]->item[$post]->title;
		$this->title=substr($this->title,12,strlen($this->title));
		$this->title=substr($this->title,0,strpos($this->title,','));
		$this->link= $xml->channel[0]->item[$post]->link;
		$this->description = $xml->channel[0]->item[$post]->description;
		return $this->parseDesc($tag);
		//echo $xml->channel[0]->item[$post]->title;
		//print $this->description;
	}

	private function downloadFile($url){
	
		
		$file = fopen($url,"rb");
		if($file){
			$newFile=fopen("/tmp/rss.xml","wb");
		}else{
			die("ERROR!\n");
		}
		
		if($newFile){
			while(!feof($file)){
				fwrite($newFile,fread($file,1024*8),1024*8);
			}
		}else{
			die("ERROR!\n");
		}
		
		if($file){
			fclose($file);
		}
		
		if($newFile){
			fclose($newFile);
		}
		
	}
	
	
	public function __destruct(){
		unlink("/tmp/rss.xml");
	}

}


//$parser = new Parser("https://www8.cs.ucy.ac.cy/conferences/colloquium/rss.xml");
//$res=$parser->parse(91,"image");
//$res=$parser->parse(90,"speaker");
//$res=$parser->parse(0,"affiliation");
//$res=$parser->parse(0,"category");
//$res=$parser->parse(0,"location");
//$res=$parser->parse(90,"date");
//$res=$parser->parse(0,"time");
//$res=$parser->parse(0,"host");
//$res=$parser->parse(0,"abstract");
//$res=$parser->parse(0,"bio");
//echo $res;



?>
